Package ghidra.app.util.bin.format.golang.rtti.types

# Class GoPointerType

java.lang.Object
ghidra.app.util.bin.format.golang.rtti.types.GoType
ghidra.app.util.bin.format.golang.rtti.types.GoPointerType

All Implemented Interfaces:
  `StructureMarkup<GoType>`

public class GoPointerType extends GoType
`GoType` structure that defines a pointer.

- ## Field Summary

  ### Fields inherited from class ghidra.app.util.bin.format.golang.rtti.types.GoType

  `context, programContext, typ, uncommonType`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GoPointerType()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `discoverGoTypes(Set<Long> discoveredTypes)`
  Iterates this type, and any types this type refers to, while registering the types with the `GoRttiMapper` context.
  `GoType`
  `getElement()`
  Returns a reference to the element's type.
  `String`
  `getStructureNamespace()`
  Returns the namespace that any labels should be placed in.
  `protected String`
  `getTypeDeclString()`
  Returns a descriptive string that defines the declaration of this type.
  `DataType`
  `recoverDataType()`
  Converts a golang RTTI type structure into a Ghidra data type.

  ### Methods inherited from class ghidra.app.util.bin.format.golang.rtti.types.GoType

  `additionalMarkup, getBaseType, getDebugId, getEndOfTypeInfo, getImplementsInterfaceString, getMethodInfoList, getMethodListString, getMethodSignature, getName, getNameWithPackageString, getOffsetEndOfFullType, getPackagePathString, getSpecializedTypeClass, getStructureContext, getStructureName, getTypeOffset, getUncommonType, getUniqueTypename, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.app.util.bin.format.golang.structmapping.StructureMarkup

  `getExternalInstancesToMarkup, getStructureLabel`

- ## Constructor Details

  - ### GoPointerType

    public GoPointerType()

- ## Method Details

  - ### getElement

    public GoType getElement() throws IOException
    Returns a reference to the element's type.
    Returns:
      reference to the element's type
    Throws:
      `IOException` - if error reading data

  - ### recoverDataType

    public DataType recoverDataType() throws IOException
    Description copied from class: `GoType`
    Converts a golang RTTI type structure into a Ghidra data type.
    Overrides:
      `recoverDataType` in class `GoType`
    Returns:
      `DataType` that represents the golang type
    Throws:
      `IOException` - if error getting name of the type

  - ### discoverGoTypes

    public boolean discoverGoTypes(Set<Long> discoveredTypes) throws IOException
    Description copied from class: `GoType`
    Iterates this type, and any types this type refers to, while registering the types with the `GoRttiMapper` context.

    This method should be overloaded by derived type classes to add any additional types referenced by the derived type.

    Overrides:
      `discoverGoTypes` in class `GoType`
    Parameters:
      `discoveredTypes` - set of already iterated types
    Returns:
      boolean boolean flag, if false the type has already been discovered, if true the type was encountered for the first time
    Throws:
      `IOException` - if error reading type info

  - ### getStructureNamespace

    public String getStructureNamespace() throws IOException
    Description copied from interface: `StructureMarkup`
    Returns the namespace that any labels should be placed in.
    Specified by:
      `getStructureNamespace` in interface `StructureMarkup<GoType>`
    Overrides:
      `getStructureNamespace` in class `GoType`
    Returns:
      name of namespace to place the label for this structure mapped type, or null
    Throws:
      `IOException` - if error generating namespace name

  - ### getTypeDeclString

    protected String getTypeDeclString() throws IOException
    Description copied from class: `GoType`
    Returns a descriptive string that defines the declaration of this type.

    This method should be overloaded by more specific types.

    Overrides:
      `getTypeDeclString` in class `GoType`
    Returns:
      descriptive string
    Throws:
      `IOException` - if error reading data